import pygame

from pykitten.kittens import AnimatedKitten

from globs import GLOBALS

class Shuriken(AnimatedKitten):
    def __init__(self, thrower, cam):
        self.thrower = thrower
        self.camera = cam
        look = thrower.look
        delay = 3

        #set images
        img_name1 = "shuri_throw"
        img_name2 = "shuri_fly"
        pos = thrower.pos

        if look < 0:
            img_name1 = img_name1 + "_l"
            img_name2 = img_name2 + "_l"
            pos = (pos[0]-32/2, pos[1]+46/2)
        else:
            pos = (pos[0]+28/2, pos[1]+46/2)

        self.thrown_images = GLOBALS["nanji"][img_name1]
        self.fly_images = GLOBALS["nanji"][img_name2]
        AnimatedKitten.__init__(self, self.thrown_images, delay)

        self.set_pos(pos)
        self.flying = 0
        self.fly_vel = (8*look, 0)

    def update(self):
        if not self.flying:
            if not self.animate and self.thrower.cur_images == "throwing":
                self.play()
            if not self.flying and \
                self.cur_image >= len(self.images)-1 and \
                self.anim_timer.counter>=self.anim_timer.interval -1:
                self.anim_timer.set_interval(3)

                self.set_images(self.fly_images)
                self.rect.size = self.image.get_size()
                pos = (self.pos[0] + 3, self.pos[1] + 3)
                self.set_pos(pos)

                self.flying = 1
                self.set_vel(self.fly_vel)

        AnimatedKitten.update(self)
        if self.off_screen():
            self.kill()
            #print "fluppp"


    def off_screen(self):
        off_x, off_y = self.camera.pos
        real_x, real_y = self.pos[0] - off_x, self.pos[1] - off_y
        screen_x, screen_y = GLOBALS["screen_size"]
        w, h = self.get_size()
        return real_x > screen_x+w or real_y > screen_y+h or real_x < -w or real_y < -h
