import pygame

from pykitten.utils import Timer
from pykitten.engine import State


class FadeState(State):
    def __init__(self, old_screen, new_screen, next_state):
        State.__init__(self)
        self.fps = 30
        self.background.blit(old_screen, (0,0))
        self.new_screen = pygame.Surface(new_screen.get_size())
        self.new_screen.blit(new_screen, (0,0))
        self.new_screen.set_alpha(0)
        self.alpha_add = 1
        self.alpha_max = 100
        self.blend_timer = Timer(2)
        self.next = next_state

    def update_other(self):
        if not self.blend_timer.update():
            return
        alpha = self.new_screen.get_alpha() + self.alpha_add
        if self.alpha_add < 15:
            self.alpha_add += 1

        self.new_screen.set_alpha(alpha)
        self.background.blit(self.new_screen, (0,0))

        if alpha > self.alpha_max:
            self.quit()


