import pygame
from pygame.locals import *

from pykitten.engine import State

from widgets import DialogBox
from dialog import dialog


class PauseState(State):
    def __init__(self, screen):
        State.__init__(self)
        self.background.blit(screen, (0,0))

    def main_start(self):
        pygame.mouse.set_visible(0)
        State.main_start(self)


class ShowDialog(PauseState):
    def __init__(self, dialog_id, screen):
        PauseState.__init__(self, screen)
        self.success = False  #otherwise levelselection gets confused o_O
        pygame.mouse.set_visible(0)
        if not dialog.has_key(dialog_id):
            print "Dialog not found"
            self.quit()
            return

        self.dbox = DialogBox(dialog[dialog_id])
        self.add_kbevent(KEYDOWN, K_x, self.dbox.update)
        self.add_kbevent(KEYDOWN, K_ESCAPE, self.quit)

    def update_other(self):
        self.dbox.draw_img()
        self.dbox.draw(self.background)
        if self.dbox.done:
            self.quit()






