import pygame

from pykitten.gui import TextArea, StaticWidget, TextLine, ClickArea
from pykitten import utils

from globs import GLOBALS



class DialogBox(StaticWidget):
    def __init__(self, dialog):
        self.done = 0
        size = (590,140)
        pos = (utils.center(size, GLOBALS["screen_size"])[0], 30)
        StaticWidget.__init__(self, size)
        self.set_pos(pos)

        self.dialog = dialog
        self.cur_page = 0

        #txt and portrait placement
        self.txt_length = 45
        self.txt_pos = (130,15)
        self.port_pos = (20,15)

        #blinky <press space> textline
        self.blink_timer = utils.Timer(20)
        self.draw_textline = 0
        self.textline = TextLine("PRESS X", fontsize=12)
        x = size[0] - self.textline.get_size()[0] - 5
        y = size[1] - self.textline.get_size()[1] - 2
        self.textline.set_pos((x,y))

        self.bg = pygame.Surface(size) #may add some border/decoration

    def draw_img(self):  #TODO: fancy letter effect
        self.blit(self.bg, (0,0))
        try:
            speaker, text = self.dialog[self.cur_page]
        except:
            self.done = 1
            return

        portraits = GLOBALS["portraits"]
        txt = TextArea(text, fontsize=15, length=self.txt_length)
        pos = utils.center(txt.get_size(), self.get_size())

        #self.blit(txt, self.txt_pos)
        self.blit(txt, (self.txt_pos[0],pos[1]))
        if portraits.has_key(speaker):
            self.blit(portraits[speaker], self.port_pos)
        if self.draw_textline:
            self.textline.draw(self)

        self.draw_border((255,255,255),2)

        #update blink timer
        if self.blink_timer.update():
            self.draw_textline = not self.draw_textline

    def update(self):
        self.draw_img()
        self.cur_page += 1
        self.done = self.cur_page > len(self.dialog)

