'''Event module

'''

import pygame

class EventGroup(list):
    """Actually just a list that can be used to store events
    """
    def __init__(self):
        """initialises list
        """
        list.__init__(self)

    def add(self, event):
        """append event to list
        """
        self.append(event)

    def rem(self, event):
        """remove event from list

        @return: True on success and False on fail
        """
        if event in self:
            self.remove(event)
            return True
        return False

    def empty(self):
        """clear list
        """
        self = []

class Event:
    """Basic event class.
    """
    def __init__(self, type, dict, callback, **kwargs):
        """Event constructor

        @param type: event type like KEYUP, MOUSEBUTTONDOWN, etc.
        @param dict: attribute of the event (see pygame.event.Event docs for more info)
        @param callback: function to be called when event is triggered
        @param kwargs: keyword arguments passed to callback
        """
        self.ev = pygame.event.Event(type, dict)
        self.callback = callback
        self.kwargs = kwargs

    def call(self):
        """call callback function
        """

        self.callback(**self.kwargs)
